/*
 * generated by Xtext 2.32.0
 */
package no.hal.quiz.xtext.serializer;

import com.google.inject.Inject;
import java.util.List;
import no.hal.quiz.xtext.services.QuizDSLGrammarAccess;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AlternativeAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public class QuizDSLSyntacticSequencer extends AbstractSyntacticSequencer {

	protected QuizDSLGrammarAccess grammarAccess;
	protected AbstractElementAlias match_BooleanAnswer_FalseKeyword_1_1_1_or_NoKeyword_1_1_0;
	protected AbstractElementAlias match_SingleListOption_HyphenMinusKeyword_0_0_0_or_XKeyword_0_0_1;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (QuizDSLGrammarAccess) access;
		match_BooleanAnswer_FalseKeyword_1_1_1_or_NoKeyword_1_1_0 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getBooleanAnswerAccess().getFalseKeyword_1_1_1()), new TokenAlias(false, false, grammarAccess.getBooleanAnswerAccess().getNoKeyword_1_1_0()));
		match_SingleListOption_HyphenMinusKeyword_0_0_0_or_XKeyword_0_0_1 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getSingleListOptionAccess().getHyphenMinusKeyword_0_0_0()), new TokenAlias(false, false, grammarAccess.getSingleListOptionAccess().getXKeyword_0_0_1()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		return "";
	}
	
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if (match_BooleanAnswer_FalseKeyword_1_1_1_or_NoKeyword_1_1_0.equals(syntax))
				emit_BooleanAnswer_FalseKeyword_1_1_1_or_NoKeyword_1_1_0(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_SingleListOption_HyphenMinusKeyword_0_0_0_or_XKeyword_0_0_1.equals(syntax))
				emit_SingleListOption_HyphenMinusKeyword_0_0_0_or_XKeyword_0_0_1(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     'no' | 'false'
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) (ambiguity) (rule start)
	 
	 * </pre>
	 */
	protected void emit_BooleanAnswer_FalseKeyword_1_1_1_or_NoKeyword_1_1_0(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     '-' | 'x'
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) (ambiguity) option=OptionAnswer
	 
	 * </pre>
	 */
	protected void emit_SingleListOption_HyphenMinusKeyword_0_0_0_or_XKeyword_0_0_1(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
